unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,ExtCtrls,StdCtrls;

Type TPanelInPanel = class;

type
  TForm1 = class(TForm)
    Button1:TButton;
    Panel1:TPanel;
    procedure Button1Click(Sender:TObject);
    procedure FormCreate(Sender:TObject);
  private
    PanelPanel: TPanelInPanel;
  public
    Function dpi(aValue:Integer):Integer;
  end;

Type TPanelInPanel = class(TPanel)
  fPanel: TPanel;
  constructor Create(TheOwner:TComponent);override;
  procedure Click;override;
  procedure Reinit;
  procedure AutoAdjustLayout(AMode:TLayoutAdjustmentPolicy;const AFromPPI,
    AToPPI,AOldFormWidth,ANewFormWidth:Integer);override;
end;


var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure TForm1.FormCreate(Sender:TObject);
begin
  PanelPanel:= TPanelInPanel.create(self);
  PanelPanel.Parent:= self;
  Application.ProcessMessages;
  PanelPanel.Reinit;
end;

Function TForm1.dpi(aValue:Integer):Integer;
begin
  Result:= (aValue * Screen.PixelsPerInch) div Form1.DesignTimePPI;
end;

procedure TForm1.Button1Click(Sender:TObject);
begin
  writeln('Form1.dpi(200):'+inttostr(Form1.dpi(200)));
  //PanelPanel.Height:= Form1.dpi(200);
  PanelPanel.SetBounds(dpi(100),dpi(100),dpi(100),dpi(200));
  writeln('PanelPanel.Height:',inttostr(Panelpanel.Height));
  PanelPanel.fPanel.Height:= PanelPanel.Height;
end;

constructor TPanelInPanel.Create(TheOwner:TComponent);
begin
  inherited Create(TheOwner);
  self.Color:= clYellow;
  writeln('Form1.dpi(100):'+inttostr(Form1.dpi(100)));
  //self.SetBounds(Form1.dpi(100),Form1.dpi(100),Form1.dpi(100),Form1.dpi(100));
  self.SetBounds(100,100,100,100);

  writeln('PanelPanel.Height:',self.Height);

  fPanel:= TPanel.Create(self);
  fPanel.Parent:= self;
  fPanel.Color:= clRed;
  //fPanel.SetBounds(Form1.dpi(20),0,Form1.dpi(60),Height);
  fPanel.SetBounds(20,0,60,Height);

end;

procedure TPanelInPanel.Click;
begin
  inherited Click;
  writeln('Click.Height:'+inttostr(Height));
  writeln('Click.InnerPannelHeight:'+inttostr(fPanel.Height));

end;

procedure TPanelInPanel.Reinit;
begin
  writeln('Reinit:PanelPanel.Height:',self.Height);
  fPanel.SetBounds(20,0,60,Height);

end;

procedure TPanelInPanel.AutoAdjustLayout(AMode:TLayoutAdjustmentPolicy;
  const AFromPPI,AToPPI,AOldFormWidth,ANewFormWidth:Integer);
begin
  inherited AutoAdjustLayout(AMode,AFromPPI,AToPPI,AOldFormWidth,ANewFormWidth);
  writeln('AutoAdjustLayout:'+inttostr(afromppi)+'->'+inttostr(atoppi));
  //self.Width:= (Height * AToPPI) div AFromPPI;
end;

end.

